//#ifndef __winLA0_h__
//#define __winLA0_h__

#include "winScanCM.h"
#define FIN 0
#define OCT 1
#define HEX 2
#define DEC 3
#define FLT 4
#define CHR 5
#define STR 6
#define DLM 7
#define NAM 8
#define ADR 9
#define UNDEF 999

typedef struct{
	int type; TCHAR ch[256];
}LaData;
int ptrLa0;TCHAR ch0,ch1; //delm̍ŌɑSp̋󔒂Ă邱Ƃɒ
TCHAR delm[]=TEXT(" ()+-*/%^<>=\"\';{},.?:|&~[]!@");
LaData laData(int type, TCHAR ch[]){
	LaData r; r.type=type;lstrcpy(r.ch,ch); return r;
}
void next(){ch0=ch1;ch1=scanMode();}
void next2(){ch0=scanMode(); ch1=scanMode();}
LaData setNext(LaData r){r.ch[ptrLa0++]=ch0;next();return r;}
LaData setNext2(LaData r){
	r.ch[ptrLa0++]=ch0;r.ch[ptrLa0++]=ch1;next2();return r;
}
LaData  setChar(LaData r, TCHAR ch){
	r.ch[ptrLa0++]=ch;return r;
}

void La0Start(){ptr=0; scanMode=scanInit; next2();}
LaData numberScan(LaData r){
	while(ch0>='0' && ch0<='9') r=setNext(r);
	return r;
}
LaData scanNumber(){
	LaData r; ptrLa0=0; r.type=DEC;	r= numberScan(r);
	if(ch0=='.'){
		r=setNext(r);r.type=FLT; r= numberScan(r);
	}
	if(ch0=='E'||ch0=='e'){
		if(ptrLa0==1 && r.ch[0]=='.') 
			{r.type=DLM;r=setChar(r,0); return r;}
		r=setChar(r, 'E'); next();r.type=FLT;
		if(ch0 == '-' || ch0=='+') r=setNext(r);
		else r=setChar(r,'+');
		r= numberScan(r);
	}
	if(ptrLa0==1 && r.ch[0]=='.') r.type=DLM;
	r=setChar(r,0); return r;
}
int HexChar(TCHAR ch){
	return (ch0>='0' && ch0<='9')||
		(ch0>='a' && ch0<='f')||(ch0>='A' && ch0<='F');
}
LaData scanHexa(){
	LaData r; ptrLa0=0; r.type=HEX;	
	r=setChar(r,'0');r=setChar(r, 'X');	next2();
	while(HexChar(ch0)){
		if(ch0>='a' && ch0<='f') r.ch[ptrLa0++] = ch0 - 'a' + 'A';
		else r=setChar(r,ch0);
		next();
	}
	return setChar(r,0);
}
LaData scanOctal(){
	LaData r; ptrLa0=0; r.type=OCT;r=setChar(r,'0');next();
	while(ch0>='0' && ch0<='7') r=setNext(r);
	return setChar(r,0);
}
LaData scanChar(){
	LaData r; ptrLa0=0; r.type=CHR;	next();
	while(inText[ptr]!=0 && ch0!='\''){
		r.ch[ptrLa0++]=ch0;
		if(ch0=='\\') {r=setChar(r, ch1);ch0=scanMode();}
		else ch0=ch1;
		ch1=scanMode();
	}
	if(ch0!='\'') err=101;
	next(); return setChar(r,0);
}
LaData scanStr(){
	LaData r; ptrLa0=0; r.type=STR;	next();
	while(inText[ptr]!=0 && ch0!='\"'){
		r=setChar(r, ch0);
		if(ch0=='\\') {r=setChar(r, ch1);ch0=scanMode();}
		else ch0=ch1;
		ch1=scanMode();
	}
	if(ch0!='\"') err=101;
	r.ch[ptrLa0++]=0; next(); return r;
}
int retStr(TCHAR tb[], TCHAR C){
	for(int i=0;tb[i]!=0;i++) if(tb[i]==C) return i;
	return -1;
}
int scanDlm1(){
	TCHAR tbl[][3]={TEXT("<<"),TEXT(">>"),TEXT("||"),TEXT("&&")};
	for(int i=0; i<4;i++) if(tbl[i][0]==ch0 &&tbl[i][1]==ch1) return 1;
	return 0;
}
int scanDlm2(){
	TCHAR tbl[][3]=	{
		TEXT("++"),TEXT("--"),TEXT("*="),TEXT("/="),TEXT("+="),
		TEXT("-="),TEXT("^="),TEXT("%-"),TEXT("|="),TEXT("&="),
		TEXT("<="),TEXT(">="),TEXT("=="),TEXT("%-"),TEXT("!="),TEXT("->")};
	for(int i=0; i<16;i++) if(tbl[i][0]==ch0 &&tbl[i][1]==ch1) return 1;
	return 0;
}
LaData scanDlm(){
	LaData r; ptrLa0=0; r.type=DLM;
	if(scanDlm1()){
			r=setNext2(r);	if(ch0=='=')r=setNext(r);
	}
	else if(scanDlm2())	r=setNext2(r);
	else r=setNext(r);
	r.ch[ptrLa0++]=0; return r;
}
LaData scanNAM(){
	LaData r; ptrLa0=0; r.type=NAM; r.ch[ptrLa0++]=ch0; next();
	while(ch0!=0 && retStr(delm, ch0)<0) r=setNext(r);
	return setChar(r,0);
}
LaData LA0(){
	while(ch0==' ' ||ch0=='\t' ||ch0==0x3000) next();
	if(ch0==0) return laData(FIN,TEXT(""));
	if(ch0=='0'){
		if(ch1=='.')             return scanNumber();
		if(ch1=='x' || ch1=='X') return scanHexa();
		if(ch1>='0' && ch1<='7') return scanOctal();
		return scanNumber();
	}
	if(ch0=='.' || (ch0>='0' && ch0<='9')) return scanNumber();
	if(ch0=='\'') return scanChar();
	if(ch0=='\"') return scanStr();
	if(retStr(delm,ch0)>=0) return scanDlm();
	return scanNAM();
}
int strMove(TCHAR out[], int ip, TCHAR inp[]){
	for(int i=0; inp[i]!=0;i++,ip++) out[ip]=inp[i];
	return ip;
}
void TestLA0(){
	TCHAR msg[9096]=TEXT("");
	TCHAR strType[][6]={TEXT("FIN"),TEXT("OCT"),TEXT("HEX"),TEXT("DEC"),TEXT("FLT"),
	TEXT("CHR"),TEXT("STR"),TEXT("DLM"),TEXT("NAM"),TEXT("ADR"),TEXT("UNDEF")};
	GetWindowText(editB,inText, 23768);
	La0Start();LaData L=LA0();
	while(L.type!=FIN){
		if(L.type>=10) L.type=10;
		lstrcat(msg, strType[L.type]);lstrcat(msg, TEXT(" "));
		lstrcat(msg, L.ch);lstrcat(msg, TEXT("\r\n"));
		
		L=LA0();
	}
	SetWindowText(dspS,msg);
}
//#endif
